/* Session.c generated by valac 0.34.9, the Vala compiler
 * generated from Session.vala, do not modify */

/*-
 * Copyright (c) 2015 Wingpanel Developers (http://launchpad.net/wingpanel)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This class is meant to remember the
 * notifications from the current session
 * and restore them in the next session.
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>


#define NOTIFICATIONS_TYPE_SESSION (notifications_session_get_type ())
#define NOTIFICATIONS_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOTIFICATIONS_TYPE_SESSION, NotificationsSession))
#define NOTIFICATIONS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOTIFICATIONS_TYPE_SESSION, NotificationsSessionClass))
#define NOTIFICATIONS_IS_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOTIFICATIONS_TYPE_SESSION))
#define NOTIFICATIONS_IS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOTIFICATIONS_TYPE_SESSION))
#define NOTIFICATIONS_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOTIFICATIONS_TYPE_SESSION, NotificationsSessionClass))

typedef struct _NotificationsSession NotificationsSession;
typedef struct _NotificationsSessionClass NotificationsSessionClass;
typedef struct _NotificationsSessionPrivate NotificationsSessionPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOTIFICATIONS_TYPE_NOTIFICATION (notifications_notification_get_type ())
#define NOTIFICATIONS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotification))
#define NOTIFICATIONS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotificationClass))
#define NOTIFICATIONS_IS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOTIFICATIONS_TYPE_NOTIFICATION))
#define NOTIFICATIONS_IS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOTIFICATIONS_TYPE_NOTIFICATION))
#define NOTIFICATIONS_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotificationClass))

typedef struct _NotificationsNotification NotificationsNotification;
typedef struct _NotificationsNotificationClass NotificationsNotificationClass;
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NotificationsNotificationPrivate NotificationsNotificationPrivate;

struct _NotificationsSession {
	GObject parent_instance;
	NotificationsSessionPrivate * priv;
};

struct _NotificationsSessionClass {
	GObjectClass parent_class;
};

struct _NotificationsSessionPrivate {
	GFile* session_file;
	GKeyFile* key;
};

struct _NotificationsNotification {
	GObject parent_instance;
	NotificationsNotificationPrivate * priv;
	gboolean data_session;
	gchar* app_name;
	gchar* summary;
	gchar* message_body;
	gchar* app_icon;
	gchar* sender;
	gchar** actions;
	gint actions_length1;
	GVariant* hints;
	gint32 expire_timeout;
	guint32 replaces_id;
	guint32 id;
	guint32 pid;
	GDateTime* timestamp;
	gint64 unix_time;
	gchar* desktop_id;
	GAppInfo* app_info;
};

struct _NotificationsNotificationClass {
	GObjectClass parent_class;
};


static gpointer notifications_session_parent_class = NULL;
static NotificationsSession* notifications_session_instance;
static NotificationsSession* notifications_session_instance = NULL;

GType notifications_session_get_type (void) G_GNUC_CONST;
#define NOTIFICATIONS_SESSION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOTIFICATIONS_TYPE_SESSION, NotificationsSessionPrivate))
enum  {
	NOTIFICATIONS_SESSION_DUMMY_PROPERTY
};
#define NOTIFICATIONS_SESSION_SESSION_FILE_NAME ".notifications.session"
#define NOTIFICATIONS_SESSION_APP_NAME_KEY "AppName"
#define NOTIFICATIONS_SESSION_APP_ICON_KEY "AppIcon"
#define NOTIFICATIONS_SESSION_SUMMARY_KEY "Summary"
#define NOTIFICATIONS_SESSION_BODY_KEY "Body"
#define NOTIFICATIONS_SESSION_ACTIONS_KEY "Actions"
#define NOTIFICATIONS_SESSION_DESKTOP_ID_KEY "DesktopID"
#define NOTIFICATIONS_SESSION_UNIX_TIME_KEY "UnixTime"
#define NOTIFICATIONS_SESSION_SENDER_KEY "Sender"
NotificationsSession* notifications_session_get_instance (void);
static NotificationsSession* notifications_session_new (void);
static NotificationsSession* notifications_session_construct (GType object_type);
static void notifications_session_create_session_file (NotificationsSession* self);
GType notifications_notification_get_type (void) G_GNUC_CONST;
GList* notifications_session_get_session_notifications (NotificationsSession* self);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
NotificationsNotification* notifications_notification_new_from_data (guint32 _id, const gchar* _app_name, const gchar* _app_icon, const gchar* _summary, const gchar* _message_body, gchar** _actions, int _actions_length1, const gchar* _desktop_id, gint64 _unix_time, const gchar* _sender);
NotificationsNotification* notifications_notification_construct_from_data (GType object_type, guint32 _id, const gchar* _app_name, const gchar* _app_icon, const gchar* _summary, const gchar* _message_body, gchar** _actions, int _actions_length1, const gchar* _desktop_id, gint64 _unix_time, const gchar* _sender);
void notifications_session_add_notification (NotificationsSession* self, NotificationsNotification* notification);
static void notifications_session_write_contents (NotificationsSession* self);
void notifications_session_remove_notification (NotificationsSession* self, NotificationsNotification* notification);
void notifications_session_clear (NotificationsSession* self);
static void notifications_session_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static gpointer _g_object_ref0 (gpointer self) {
#line 46 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	return self ? g_object_ref (self) : NULL;
#line 143 "Session.c"
}


NotificationsSession* notifications_session_get_instance (void) {
	NotificationsSession* result = NULL;
	NotificationsSession* _tmp0_ = NULL;
	NotificationsSession* _tmp2_ = NULL;
	NotificationsSession* _tmp3_ = NULL;
#line 42 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp0_ = notifications_session_instance;
#line 42 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	if (_tmp0_ == NULL) {
#line 156 "Session.c"
		NotificationsSession* _tmp1_ = NULL;
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp1_ = notifications_session_new ();
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_object_unref0 (notifications_session_instance);
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		notifications_session_instance = _tmp1_;
#line 164 "Session.c"
	}
#line 46 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp2_ = notifications_session_instance;
#line 46 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 46 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	result = _tmp3_;
#line 46 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	return result;
#line 174 "Session.c"
}


static NotificationsSession* notifications_session_construct (GType object_type) {
	NotificationsSession * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GKeyFile* _tmp6_ = NULL;
	GKeyFile* _tmp7_ = NULL;
#line 49 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	self = (NotificationsSession*) g_object_new (object_type, NULL);
#line 50 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 50 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp1_ = g_build_filename (_tmp0_, NOTIFICATIONS_SESSION_SESSION_FILE_NAME, NULL);
#line 50 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp2_ = _tmp1_;
#line 50 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 50 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_g_object_unref0 (self->priv->session_file);
#line 50 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	self->priv->session_file = _tmp3_;
#line 50 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_g_free0 (_tmp2_);
#line 51 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp4_ = self->priv->session_file;
#line 51 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 51 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	if (!_tmp5_) {
#line 52 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		notifications_session_create_session_file (self);
#line 212 "Session.c"
	}
#line 55 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp6_ = g_key_file_new ();
#line 55 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_g_key_file_unref0 (self->priv->key);
#line 55 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	self->priv->key = _tmp6_;
#line 56 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp7_ = self->priv->key;
#line 56 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_key_file_set_list_separator (_tmp7_, ';');
#line 49 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	return self;
#line 226 "Session.c"
}


static NotificationsSession* notifications_session_new (void) {
#line 49 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	return notifications_session_construct (NOTIFICATIONS_TYPE_SESSION);
#line 233 "Session.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 240 "Session.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_list_free (self);
#line 249 "Session.c"
}


GList* notifications_session_get_session_notifications (NotificationsSession* self) {
	GList* result = NULL;
	GList* list = NULL;
	GError * _inner_error_ = NULL;
#line 59 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	list = NULL;
#line 261 "Session.c"
	{
		GKeyFile* _tmp0_ = NULL;
		GFile* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		GKeyFile* _tmp4_ = NULL;
		gsize _tmp5_;
		gchar** _tmp6_ = NULL;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp0_ = self->priv->key;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp1_ = self->priv->session_file;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp2_ = g_file_get_path (_tmp1_);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp3_ = _tmp2_;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_key_file_load_from_file (_tmp0_, _tmp3_, G_KEY_FILE_NONE, &_inner_error_);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_free0 (_tmp3_);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 286 "Session.c"
				goto __catch12_g_key_file_error;
			}
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			if (_inner_error_->domain == G_FILE_ERROR) {
#line 291 "Session.c"
				goto __catch12_g_file_error;
			}
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			__g_list_free__g_object_unref0_0 (list);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			g_clear_error (&_inner_error_);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			return NULL;
#line 302 "Session.c"
		}
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp4_ = self->priv->key;
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp6_ = g_key_file_get_groups (_tmp4_, &_tmp5_);
#line 308 "Session.c"
		{
			gchar** group_collection = NULL;
			gint group_collection_length1 = 0;
			gint _group_collection_size_ = 0;
			gint group_it = 0;
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			group_collection = _tmp6_;
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			group_collection_length1 = _tmp5_;
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			for (group_it = 0; group_it < _tmp5_; group_it = group_it + 1) {
#line 320 "Session.c"
				const gchar* group = NULL;
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
				group = group_collection[group_it];
#line 324 "Session.c"
				{
					gchar* _tmp7_ = NULL;
					GKeyFile* _tmp8_ = NULL;
					const gchar* _tmp9_ = NULL;
					gchar* _tmp10_ = NULL;
					gchar* _tmp11_ = NULL;
					GKeyFile* _tmp12_ = NULL;
					const gchar* _tmp13_ = NULL;
					gchar* _tmp14_ = NULL;
					gchar* _tmp15_ = NULL;
					GKeyFile* _tmp16_ = NULL;
					const gchar* _tmp17_ = NULL;
					gchar* _tmp18_ = NULL;
					gchar* _tmp19_ = NULL;
					GKeyFile* _tmp20_ = NULL;
					const gchar* _tmp21_ = NULL;
					gchar* _tmp22_ = NULL;
					gchar** _tmp23_ = NULL;
					GKeyFile* _tmp24_ = NULL;
					const gchar* _tmp25_ = NULL;
					gsize _tmp26_;
					gchar** _tmp27_ = NULL;
					gint _tmp23__length1 = 0;
					gint __tmp23__size_ = 0;
					gchar* _tmp28_ = NULL;
					GKeyFile* _tmp29_ = NULL;
					const gchar* _tmp30_ = NULL;
					gchar* _tmp31_ = NULL;
					gint64 _tmp32_ = 0LL;
					GKeyFile* _tmp33_ = NULL;
					const gchar* _tmp34_ = NULL;
					gint64 _tmp35_ = 0LL;
					gchar* _tmp36_ = NULL;
					GKeyFile* _tmp37_ = NULL;
					const gchar* _tmp38_ = NULL;
					gchar* _tmp39_ = NULL;
					NotificationsNotification* notification = NULL;
					const gchar* _tmp40_ = NULL;
					gint _tmp41_ = 0;
					NotificationsNotification* _tmp42_ = NULL;
					NotificationsNotification* _tmp43_ = NULL;
					NotificationsNotification* _tmp44_ = NULL;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp8_ = self->priv->key;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp9_ = group;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp10_ = g_key_file_get_string (_tmp8_, _tmp9_, NOTIFICATIONS_SESSION_APP_NAME_KEY, &_inner_error_);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp7_ = _tmp10_;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 381 "Session.c"
							goto __catch12_g_key_file_error;
						}
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_FILE_ERROR) {
#line 386 "Session.c"
							goto __catch12_g_file_error;
						}
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						__g_list_free__g_object_unref0_0 (list);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_clear_error (&_inner_error_);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						return NULL;
#line 399 "Session.c"
					}
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp12_ = self->priv->key;
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp13_ = group;
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp14_ = g_key_file_get_string (_tmp12_, _tmp13_, NOTIFICATIONS_SESSION_APP_ICON_KEY, &_inner_error_);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp11_ = _tmp14_;
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 417 "Session.c"
							goto __catch12_g_key_file_error;
						}
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_FILE_ERROR) {
#line 422 "Session.c"
							goto __catch12_g_file_error;
						}
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						__g_list_free__g_object_unref0_0 (list);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_clear_error (&_inner_error_);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						return NULL;
#line 437 "Session.c"
					}
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp16_ = self->priv->key;
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp17_ = group;
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp18_ = g_key_file_get_string (_tmp16_, _tmp17_, NOTIFICATIONS_SESSION_SUMMARY_KEY, &_inner_error_);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp15_ = _tmp18_;
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 457 "Session.c"
							goto __catch12_g_key_file_error;
						}
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_FILE_ERROR) {
#line 462 "Session.c"
							goto __catch12_g_file_error;
						}
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						__g_list_free__g_object_unref0_0 (list);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_clear_error (&_inner_error_);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						return NULL;
#line 479 "Session.c"
					}
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp20_ = self->priv->key;
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp21_ = group;
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp22_ = g_key_file_get_string (_tmp20_, _tmp21_, NOTIFICATIONS_SESSION_BODY_KEY, &_inner_error_);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp19_ = _tmp22_;
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 501 "Session.c"
							goto __catch12_g_key_file_error;
						}
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_FILE_ERROR) {
#line 506 "Session.c"
							goto __catch12_g_file_error;
						}
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						__g_list_free__g_object_unref0_0 (list);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_clear_error (&_inner_error_);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						return NULL;
#line 525 "Session.c"
					}
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp24_ = self->priv->key;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp25_ = group;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp27_ = g_key_file_get_string_list (_tmp24_, _tmp25_, NOTIFICATIONS_SESSION_ACTIONS_KEY, &_tmp26_, &_inner_error_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp23_ = _tmp27_;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp23__length1 = _tmp26_;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					__tmp23__size_ = _tmp23__length1;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 553 "Session.c"
							goto __catch12_g_key_file_error;
						}
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_FILE_ERROR) {
#line 558 "Session.c"
							goto __catch12_g_file_error;
						}
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						__g_list_free__g_object_unref0_0 (list);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_clear_error (&_inner_error_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						return NULL;
#line 579 "Session.c"
					}
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp29_ = self->priv->key;
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp30_ = group;
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp31_ = g_key_file_get_string (_tmp29_, _tmp30_, NOTIFICATIONS_SESSION_DESKTOP_ID_KEY, &_inner_error_);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp28_ = _tmp31_;
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 605 "Session.c"
							goto __catch12_g_key_file_error;
						}
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_FILE_ERROR) {
#line 610 "Session.c"
							goto __catch12_g_file_error;
						}
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						__g_list_free__g_object_unref0_0 (list);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_clear_error (&_inner_error_);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						return NULL;
#line 633 "Session.c"
					}
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp33_ = self->priv->key;
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp34_ = group;
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp35_ = g_key_file_get_int64 (_tmp33_, _tmp34_, NOTIFICATIONS_SESSION_UNIX_TIME_KEY, &_inner_error_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp32_ = _tmp35_;
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp28_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 661 "Session.c"
							goto __catch12_g_key_file_error;
						}
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_FILE_ERROR) {
#line 666 "Session.c"
							goto __catch12_g_file_error;
						}
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp28_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						__g_list_free__g_object_unref0_0 (list);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_clear_error (&_inner_error_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						return NULL;
#line 691 "Session.c"
					}
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp37_ = self->priv->key;
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp38_ = group;
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp39_ = g_key_file_get_string (_tmp37_, _tmp38_, NOTIFICATIONS_SESSION_SENDER_KEY, &_inner_error_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp36_ = _tmp39_;
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp28_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 719 "Session.c"
							goto __catch12_g_key_file_error;
						}
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						if (_inner_error_->domain == G_FILE_ERROR) {
#line 724 "Session.c"
							goto __catch12_g_file_error;
						}
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp28_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp19_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp15_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp11_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						_g_free0 (_tmp7_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						__g_list_free__g_object_unref0_0 (list);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						g_clear_error (&_inner_error_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
						return NULL;
#line 749 "Session.c"
					}
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp40_ = group;
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp41_ = atoi (_tmp40_);
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp42_ = notifications_notification_new_from_data ((guint32) _tmp41_, _tmp7_, _tmp11_, _tmp15_, _tmp19_, _tmp23_, _tmp23__length1, _tmp28_, _tmp32_, _tmp36_);
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					notification = _tmp42_;
#line 73 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp43_ = notification;
#line 73 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp44_ = _g_object_ref0 (_tmp43_);
#line 73 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					list = g_list_append (list, _tmp44_);
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_g_object_unref0 (notification);
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_g_free0 (_tmp36_);
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_g_free0 (_tmp28_);
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_g_free0 (_tmp19_);
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_g_free0 (_tmp15_);
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_g_free0 (_tmp11_);
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
					_g_free0 (_tmp7_);
#line 781 "Session.c"
				}
			}
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 786 "Session.c"
		}
	}
	goto __finally12;
	__catch12_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp45_ = NULL;
		const gchar* _tmp46_ = NULL;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		e = _inner_error_;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_inner_error_ = NULL;
#line 76 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp45_ = e;
#line 76 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp46_ = _tmp45_->message;
#line 76 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_warning ("Session.vala:76: %s", _tmp46_);
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_error_free0 (e);
#line 807 "Session.c"
	}
	goto __finally12;
	__catch12_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp47_ = NULL;
		const gchar* _tmp48_ = NULL;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		e = _inner_error_;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_inner_error_ = NULL;
#line 78 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp47_ = e;
#line 78 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp48_ = _tmp47_->message;
#line 78 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_warning ("Session.vala:78: %s", _tmp48_);
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_error_free0 (e);
#line 827 "Session.c"
	}
	__finally12:
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		__g_list_free__g_object_unref0_0 (list);
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_clear_error (&_inner_error_);
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		return NULL;
#line 840 "Session.c"
	}
#line 81 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	result = list;
#line 81 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	return result;
#line 846 "Session.c"
}


void notifications_session_add_notification (NotificationsSession* self, NotificationsNotification* notification) {
	gchar* id = NULL;
	NotificationsNotification* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	gchar* _tmp2_ = NULL;
	GKeyFile* _tmp3_ = NULL;
	NotificationsNotification* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	GKeyFile* _tmp6_ = NULL;
	NotificationsNotification* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	GKeyFile* _tmp9_ = NULL;
	NotificationsNotification* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	GKeyFile* _tmp12_ = NULL;
	NotificationsNotification* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	GKeyFile* _tmp15_ = NULL;
	NotificationsNotification* _tmp16_ = NULL;
	gchar** _tmp17_ = NULL;
	gint _tmp17__length1 = 0;
	GKeyFile* _tmp18_ = NULL;
	NotificationsNotification* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	GKeyFile* _tmp21_ = NULL;
	NotificationsNotification* _tmp22_ = NULL;
	gint64 _tmp23_ = 0LL;
	GKeyFile* _tmp24_ = NULL;
	NotificationsNotification* _tmp25_ = NULL;
	const gchar* _tmp26_ = NULL;
#line 84 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_return_if_fail (self != NULL);
#line 84 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_return_if_fail (notification != NULL);
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp0_ = notification;
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp1_ = _tmp0_->id;
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp2_ = g_strdup_printf ("%u", _tmp1_);
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	id = _tmp2_;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp3_ = self->priv->key;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp4_ = notification;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp5_ = _tmp4_->app_name;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_key_file_set_string (_tmp3_, id, NOTIFICATIONS_SESSION_APP_NAME_KEY, _tmp5_);
#line 87 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp6_ = self->priv->key;
#line 87 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp7_ = notification;
#line 87 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp8_ = _tmp7_->app_icon;
#line 87 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_key_file_set_string (_tmp6_, id, NOTIFICATIONS_SESSION_APP_ICON_KEY, _tmp8_);
#line 88 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp9_ = self->priv->key;
#line 88 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp10_ = notification;
#line 88 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp11_ = _tmp10_->summary;
#line 88 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_key_file_set_string (_tmp9_, id, NOTIFICATIONS_SESSION_SUMMARY_KEY, _tmp11_);
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp12_ = self->priv->key;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp13_ = notification;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp14_ = _tmp13_->message_body;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_key_file_set_string (_tmp12_, id, NOTIFICATIONS_SESSION_BODY_KEY, _tmp14_);
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp15_ = self->priv->key;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp16_ = notification;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp17_ = _tmp16_->actions;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp17__length1 = _tmp16_->actions_length1;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_key_file_set_string_list (_tmp15_, id, NOTIFICATIONS_SESSION_ACTIONS_KEY, (const gchar* const*) _tmp17_, _tmp17__length1);
#line 91 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp18_ = self->priv->key;
#line 91 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp19_ = notification;
#line 91 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp20_ = _tmp19_->desktop_id;
#line 91 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_key_file_set_string (_tmp18_, id, NOTIFICATIONS_SESSION_DESKTOP_ID_KEY, _tmp20_);
#line 92 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp21_ = self->priv->key;
#line 92 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp22_ = notification;
#line 92 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp23_ = _tmp22_->unix_time;
#line 92 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_key_file_set_int64 (_tmp21_, id, NOTIFICATIONS_SESSION_UNIX_TIME_KEY, _tmp23_);
#line 93 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp24_ = self->priv->key;
#line 93 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp25_ = notification;
#line 93 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_tmp26_ = _tmp25_->sender;
#line 93 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_key_file_set_string (_tmp24_, id, NOTIFICATIONS_SESSION_SENDER_KEY, _tmp26_);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	notifications_session_write_contents (self);
#line 84 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_g_free0 (id);
#line 962 "Session.c"
}


void notifications_session_remove_notification (NotificationsSession* self, NotificationsNotification* notification) {
	GError * _inner_error_ = NULL;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_return_if_fail (self != NULL);
#line 98 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_return_if_fail (notification != NULL);
#line 972 "Session.c"
	{
		GKeyFile* _tmp0_ = NULL;
		NotificationsNotification* _tmp1_ = NULL;
		guint32 _tmp2_ = 0U;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp0_ = self->priv->key;
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp1_ = notification;
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp2_ = _tmp1_->id;
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp3_ = g_strdup_printf ("%u", _tmp2_);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp4_ = _tmp3_;
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_key_file_remove_group (_tmp0_, _tmp4_, &_inner_error_);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_free0 (_tmp4_);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 997 "Session.c"
				goto __catch13_g_key_file_error;
			}
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			g_clear_error (&_inner_error_);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			return;
#line 1006 "Session.c"
		}
	}
	goto __finally13;
	__catch13_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		e = _inner_error_;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_inner_error_ = NULL;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp5_ = e;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp6_ = _tmp5_->message;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_warning ("Session.vala:102: %s", _tmp6_);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_error_free0 (e);
#line 1027 "Session.c"
	}
	__finally13:
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_clear_error (&_inner_error_);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		return;
#line 1038 "Session.c"
	}
#line 105 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	notifications_session_write_contents (self);
#line 1042 "Session.c"
}


void notifications_session_clear (NotificationsSession* self) {
	GError * _inner_error_ = NULL;
#line 108 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_return_if_fail (self != NULL);
#line 1050 "Session.c"
	{
		GFile* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp0_ = self->priv->session_file;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp1_ = g_file_get_path (_tmp0_);
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp2_ = _tmp1_;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_file_set_contents (_tmp2_, "", (gssize) -1, &_inner_error_);
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_free0 (_tmp2_);
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			if (_inner_error_->domain == G_FILE_ERROR) {
#line 1069 "Session.c"
				goto __catch14_g_file_error;
			}
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			g_clear_error (&_inner_error_);
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			return;
#line 1078 "Session.c"
		}
	}
	goto __finally14;
	__catch14_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		e = _inner_error_;
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_inner_error_ = NULL;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp3_ = e;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp4_ = _tmp3_->message;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_warning ("Session.vala:112: %s", _tmp4_);
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_error_free0 (e);
#line 1099 "Session.c"
	}
	__finally14:
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_clear_error (&_inner_error_);
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		return;
#line 1110 "Session.c"
	}
}


static void notifications_session_create_session_file (NotificationsSession* self) {
	GError * _inner_error_ = NULL;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_return_if_fail (self != NULL);
#line 1119 "Session.c"
	{
		GFile* _tmp0_ = NULL;
		GFileOutputStream* _tmp1_ = NULL;
		GFileOutputStream* _tmp2_ = NULL;
#line 118 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp0_ = self->priv->session_file;
#line 118 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp1_ = g_file_create (_tmp0_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
#line 118 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp2_ = _tmp1_;
#line 118 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_object_unref0 (_tmp2_);
#line 118 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1134 "Session.c"
			goto __catch15_g_error;
		}
	}
	goto __finally15;
	__catch15_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
#line 117 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		e = _inner_error_;
#line 117 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_inner_error_ = NULL;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp3_ = e;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp4_ = _tmp3_->message;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_warning ("Session.vala:120: %s", _tmp4_);
#line 117 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_error_free0 (e);
#line 1156 "Session.c"
	}
	__finally15:
#line 117 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 117 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 117 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_clear_error (&_inner_error_);
#line 117 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		return;
#line 1167 "Session.c"
	}
}


static void notifications_session_write_contents (NotificationsSession* self) {
	GError * _inner_error_ = NULL;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_return_if_fail (self != NULL);
#line 1176 "Session.c"
	{
		GFile* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GKeyFile* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp0_ = self->priv->session_file;
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp1_ = g_file_get_path (_tmp0_);
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp2_ = _tmp1_;
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp3_ = self->priv->key;
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp4_ = g_key_file_to_data (_tmp3_, NULL, NULL);
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp5_ = _tmp4_;
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_file_set_contents (_tmp2_, _tmp5_, (gssize) -1, &_inner_error_);
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_free0 (_tmp5_);
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_free0 (_tmp2_);
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			if (_inner_error_->domain == G_FILE_ERROR) {
#line 1206 "Session.c"
				goto __catch16_g_file_error;
			}
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			g_clear_error (&_inner_error_);
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
			return;
#line 1215 "Session.c"
		}
	}
	goto __finally16;
	__catch16_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 125 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		e = _inner_error_;
#line 125 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_inner_error_ = NULL;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp6_ = e;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_tmp7_ = _tmp6_->message;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_warning ("Session.vala:128: %s", _tmp7_);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		_g_error_free0 (e);
#line 1236 "Session.c"
	}
	__finally16:
#line 125 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 125 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		g_clear_error (&_inner_error_);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
		return;
#line 1247 "Session.c"
	}
}


static void notifications_session_class_init (NotificationsSessionClass * klass) {
#line 24 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	notifications_session_parent_class = g_type_class_peek_parent (klass);
#line 24 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	g_type_class_add_private (klass, sizeof (NotificationsSessionPrivate));
#line 24 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	G_OBJECT_CLASS (klass)->finalize = notifications_session_finalize;
#line 1259 "Session.c"
}


static void notifications_session_instance_init (NotificationsSession * self) {
#line 24 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	self->priv = NOTIFICATIONS_SESSION_GET_PRIVATE (self);
#line 28 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	self->priv->session_file = NULL;
#line 1268 "Session.c"
}


static void notifications_session_finalize (GObject* obj) {
	NotificationsSession * self;
#line 24 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOTIFICATIONS_TYPE_SESSION, NotificationsSession);
#line 28 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_g_object_unref0 (self->priv->session_file);
#line 39 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	_g_key_file_unref0 (self->priv->key);
#line 24 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0.3/src/Services/Session.vala"
	G_OBJECT_CLASS (notifications_session_parent_class)->finalize (obj);
#line 1282 "Session.c"
}


GType notifications_session_get_type (void) {
	static volatile gsize notifications_session_type_id__volatile = 0;
	if (g_once_init_enter (&notifications_session_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NotificationsSessionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notifications_session_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationsSession), 0, (GInstanceInitFunc) notifications_session_instance_init, NULL };
		GType notifications_session_type_id;
		notifications_session_type_id = g_type_register_static (G_TYPE_OBJECT, "NotificationsSession", &g_define_type_info, 0);
		g_once_init_leave (&notifications_session_type_id__volatile, notifications_session_type_id);
	}
	return notifications_session_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



